# Copyright (c) 2020 Jerome Arbez-Gindre
# frozen_string_literal: true

module DefMastership
  # Contains regexp / action couples
  Filter = Struct.new(:regexp, :event, :consumed_line)
  private_constant :Filter

  FILTERS = [
    Filter.new(DMRegexp::VARIABLE_DEF,  :new_variable_def,     false),
    Filter.new(DMRegexp::VARIABLE_USE,  :new_variable_use,     false),
    Filter.new(DMRegexp::DEFINITION,    :new_definition,       true),
    Filter.new(DMRegexp::EREF_CONFIG,   :new_eref_setup,       true),
    Filter.new(DMRegexp::EREF_DEF,      :new_eref_def,         false),
    Filter.new(DMRegexp::IREF_DEF,      :new_iref_def,         false),
    Filter.new(DMRegexp::ATTR_CONFIG,   :new_attribute_conf,   true),
    Filter.new(DMRegexp::ATTR_SET,      :new_attribute_value,  false),
    Filter.new(DMRegexp::BLOCK,         :block_delimiter,      true),
    Filter.new(DMRegexp::EMPTY_LINE,    :empty_line,           false),
    Filter.new(DMRegexp::WHATEVER,      :new_line,             true)
  ].freeze
  private_constant :FILTERS
end
