# Copyright (c) 2020 Jerome Arbez-Gindre
# frozen_string_literal: true

module DefMastership
  # Change references from temporary to definitive with multiple RefChangers
  class LineModifierBase
    attr_reader :changes, :config

    def initialize
      @config = {}
      @changes = []
    end

    def method_missing(method_name, *args, &block)
      return @config[method_name] if @config[method_name]

      super
    end

    def respond_to_missing?(method_name, *args)
      @config[method_name] || super
    end

    def from_config(config)
      @config.merge!(config)
      self
    end
  end
end
