# Copyright (c) 2020 Jerome Arbez-Gindre
# frozen_string_literal: true

module DefMastership
  # Change references from temporary to definitive with multiple RefChangers
  class ModifierBase
    attr_reader :config, :changes

    def initialize(config)
      @config = config
      @changes = []
    end

    def do_modifications(adoc_texts)
      line_modifier = new_line_modifier(@config, adoc_texts)

      adoc_texts =
        replacements.reduce(adoc_texts) do |texts, method|
          texts.transform_values do |text|
            text.lines.map { |line| line_modifier.public_send(method, line) }.join
          end
        end

      @config = line_modifier.config
      @changes = line_modifier.changes
      adoc_texts
    end
  end
end
