# Copyright (c) 2020 Jerome Arbez-Gindre
# frozen_string_literal: true

module DefMastership
  # Allow to know if we need to parse the line or simply ignore it
  class ParsingState
    def initialize
      @last_disabling_line = nil
    end

    def enabled?(line)
      return false if line.match(DMRegexp::SINGLE_LINE_COMMENT)

      line = line.dup.chomp
      if ['....', '----', '////'].include?(line)
        if @last_disabling_line == line
          @last_disabling_line = nil
        elsif @last_disabling_line.nil?
          @last_disabling_line = line
        end
      end
      @last_disabling_line.nil?
    end
  end
end
