# Copyright (c) 2020 Jerome Arbez-Gindre
# frozen_string_literal: true

module DefMastership
  # modify one line after another
  class UpdateDefChecksumLineModifier < LineModifierBase
    attr_accessor :document

    def self.from_config(hash)
      new.from_config(hash)
    end

    def initialize
      super
      @config = {
        def_type: ''
      }
    end

    def replace(line)
      match = matched?(line)

      return line unless match
      return line unless match[:type] == def_type

      line.gsub(Regexp.new("#{match[:reference]}#{DMRegexp::DEF_VERSION_AND_CHECKSUM}")) do
        "#{match[:reference]}(#{match[:explicit_version]}#{@document.ref_to_def(match[:reference]).sha256})"
      end
    end

    def matched?(line)
      return if line.commented?
      return unless line =~ DMRegexp::DEFINITION

      Regexp.last_match
    end
  end
end
