# Copyright (c) 2020 Jerome Arbez-Gindre
# frozen_string_literal: true

module DefMastership
  # Update definition checksum with calculated one
  class UpdateDefChecksumModifier < ModifierBase
    def replacements
      %i[replace]
    end

    def new_line_modifier(config, adoc_texts)
      document = Document.new
      adoc_texts.each do |adoc_file, _|
        document.parse_file_with_preprocessor(adoc_file)
      end
      line_modifier = UpdateDefChecksumLineModifier.from_config(config)
      line_modifier.document = document
      line_modifier
    end
  end
end
